import logging
from .http_client import HTTP
from .utils import Logging

log = logging.getLogger(__name__)
log.setLevel(Logging.channel.LEVEL)
logging.basicConfig(format=Logging.FORMAT)

class DiscordChannel:
    def __init__(self, channel_id, token, loop=None):
        self.id = str(channel_id)
        self.loop = loop
        self.token = token

        self.http = HTTP(token=self.token, loop=self.loop)

    async def send(self, content, tts=False):
        data = {
            "content": content,
            "tts": tts
        }
        await self.http.post("/channels/" + str(self.id) + "/messages", data=data)