import logging

class API:
    LEVEL = 6

class Logging:
    FORMAT = '[%(levelname)s] (%(asctime)s): %(name)s - %(message)s'

    class http_client:
        LEVEL = logging.DEBUG

    class gateway:
        LEVEL = logging.DEBUG

    class client:
        LEVEL = logging.INFO

    class channel:
        LEVEL = logging.INFO

class exceptions:
    class DiscordoBaseException(Exception):
        pass

    class AuthenticationFailed(DiscordoBaseException):
        pass

    class UnknownError(DiscordoBaseException):
        pass
    
    def exception_handler(loop, context):
        loop.default_exception_handler(context)

        exception = context.get('exception')
        if isinstance(exception, exceptions.AuthenticationFailed) or isinstance(exception, exceptions.UnknownError):
            print(context)
            loop.stop()